#include <bits/stdc++.h>

#define INF 1000000005
#define EPS 1e-6
#define pb push_back
#define pause system("pause")
#define exit exit(0)
#define endl '\n'

using namespace std;
using ull = unsigned long long;
using ll = long long;

typedef pair<int, int> pii;
const int N = 200005, LG = 21, K = 320, MOD = 998244353;

int n, l, sz[N], hd[N], nxt[N << 1], tr[N << 1], ct[N << 1], cntE;
char del[N];

void add_e(int u, int v, int w) {
        tr[++cntE] = v;
        nxt[cntE] = hd[u];
        hd[u] = cntE;
        ct[cntE] = w;
}

void siz(int u, int p = -1) {
        sz[u] = 1;
        int e = hd[u];
        while (e) {
                int v = tr[e];
                if (v != p && !del[v]) {
                        siz(v, u);
                        sz[u] += sz[v];
                }

                e = nxt[e];
        }
}

int ctr(int u, int n, int p = -1) {
        int e = hd[u];
        while (e) {
                int v = tr[e];
                if (v != p && !del[v] && sz[v] > (n >> 1)) {
                        return ctr(v, n, u);
                }

                e = nxt[e];
        }

        return u;
}

int ans, lst_ptr, dst[N], cnt[N];
void dfs(int u, int cr, int c = 1, int p = -1) {
        if (cr > l) return;
        dst[lst_ptr] = cr, cnt[lst_ptr++] = c;
        int e = hd[u];
        while (e) {
                int v = tr[e], w = ct[e];
                if (v != p && !del[v]) {
                        dfs(v, cr + w, c + 1, u);
                }

                e = nxt[e];
        }
}

void solve(int u) {
        siz(u);
        del[u] = 1;
        int e = hd[u];
        map<int, int> mn;
        mn[0] = 0;
        while (e) {
                int v = tr[e], w = ct[e];
                if (!del[v]) {
                        lst_ptr = 0;
                        dfs(v, w);
                        for (int i = 0; i < lst_ptr; ++i) {
                                if (mn.count(l - dst[i])) {
                                        ans = min(ans, cnt[i] + mn[l - dst[i]] + 1);
                                }
                        }

                        for (int i = 0; i < lst_ptr; ++i) {
                                if (!mn.count(dst[i]) || mn[dst[i]] > cnt[i]) {
                                        mn[dst[i]] = cnt[i];
                                }
                        }
                }

                e = nxt[e];
        };

        e = hd[u];
        while (e) {
                int v = tr[e];
                if (!del[v]) {
                        solve(ctr(v, sz[v]));
                }

                e = nxt[e];
        }
}

bool us[N];
void dfs2(int u, int c = 1, int d = 0) {
        if (d > l) return;
        if (d == l) {
                ans = min(ans, c);
                return;
        }

        us[u] = 1;
        int v, w, e = hd[u];
        while (e) {
                v = tr[e], w = ct[e];
                if (!us[v]) {
                        dfs2(v, c + 1, d + w);
                }

                e = nxt[e];
        }
        us[u] = 0;
}

int solve2() {
        ans = INF;
        for (int i = 1; i <= n; ++i) {
                dfs2(i);
        }

        return ans;
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(0), cout.tie(0);

        cin >> n >> l;
        for (int i = 0, u, v, w; i < n - 1; ++i) {
                cin >> u >> v >> w;
                add_e(u, v, w);
                add_e(v, u, w);
        }

        if (n >= 5 && n < 100) {
                cout << solve2() << endl;
                return 0;
        }

        ans = INF;
        for (int i = 1; i <= n; ++i) {
                if (!del[i]) {
                        siz(i);
                        solve(ctr(i, sz[i]));
                }
        }

        cout << (ans == INF ? -1 : ans) << endl;
        //pause;
        return 0;
}