#include <bits/stdc++.h>

#define INF (int)2e9
#define EPS 1e-8
#define pb push_back
#define pause system("pause")
#define exit exit(0)
#define endl '\n'
#define fi first
#define se second

using namespace std;
using ull = unsigned long long;
using ll = long long;

typedef pair<ll, ll> pii;
const int N = 200005, LG = 18, MOD = 998244353;

int n, l, vis[N], sz[N];
vector<pii> g[N];
ll ans = INF;

void szs(int u, int p = -1) {
	sz[u] = 1;
	for (auto v : g[u]) {
		if (!vis[v.fi] && v.fi != p) {
			szs(v.fi, u);
			sz[u] += sz[v.fi];
		}
	}
}

int ctr(int u, int p, int n) {
	for (auto v : g[u]) {
		if (!vis[v.fi] && v.fi != p && 2 * sz[v.fi] > n) return ctr(v.fi, u, n);
	}

	return u;
}

void dfs(int u, int p, vector<pii> &d, int ct, ll ln) {
	if (ln > l) return;
	d.pb({ ct, ln });
	for (auto v : g[u]) {
		if (v.fi != p && !vis[v.fi]) {
			dfs(v.fi, u, d, ct + 1, ln + v.se);
		}
	}
}

void go(int u) {
	map<ll, ll> mn;
	vis[u] = 1;
	szs(u);
	for (auto e : g[u]) {
		int v = e.fi;
		if (vis[v]) continue;
		vector<pii> d;
		dfs(v, u, d, 2, e.se);
		for (auto x : d) {
			if (x.se == l) {
				ans = min(ans, x.fi);
			}

			if (mn.count(l - x.se)) {
				ans = min(ans, x.fi + mn[l - x.se] - 1);
			}
		}

		for (auto x : d) {
			if (!mn.count(x.se)) {
				mn[x.se] = x.fi;
				continue;
			}

			mn[x.se] = min(mn[x.se], x.fi);
		}
	}

	for (auto v : g[u]) {
		if (!vis[v.fi]) {
			go(ctr(v.fi, u, sz[v.fi]));
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	cin >> n >> l;
	for (int i = 0, u, v, l; i < n - 1; ++i) {
		cin >> u >> v >> l;
		g[u].pb({ v, l }), g[v].pb({ u, l });
	}

	go(1);

	cout << (ans == INF ? -1 : ans) << endl;
	//pause;
	return 0;
}